var CustomGeometrySetup = {
	SelectedIndex: -1,

	initOptions: function()
	{
		try
		{
			//Prefs
			var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
			var GeometryStore = '';
			var GeometryList;
			var GeometrySplit;
			var GeometryArray;
			var GeometryIndex;
			var Name;
			var Width;
			var Height;
			var Left;
			var Top;
			var OneRow;
			var OneCell;
			
			
			CustomGeometrySetup.SelectedIndex = -1;
			
			//Prefill
			if(oPrefs.prefHasUserValue("customgeometry.options.list"))
				GeometryStore = oPrefs.getCharPref("customgeometry.options.list");
			
			if (GeometryStore == '')
				GeometryStore = "Default^1192^1170^728^0";
			
			GeometrySplit = GeometryStore.split('~');
			GeometryList = document.getElementById("customgeometry.options.GeometryList");
			
			for (GeometryIndex=0; GeometryIndex<GeometrySplit.length; GeometryIndex++)
			{
				GeometryArray = GeometrySplit[GeometryIndex].split('^');
				Name = GeometryArray[0];
				Width = GeometryArray[1];
				Height = GeometryArray[2];
				Left = GeometryArray[3];
				Top = GeometryArray[4];
				
				OneRow = document.createElement("listitem");
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Name);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Width);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Height);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Left);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Top);
				OneRow.appendChild(OneCell);
				
				GeometryList.appendChild(OneRow)
			}
		} catch(err) { alert(err); }
	},

	saveOptions: function()
	{
		
		CustomGeometrySetup.SelectedIndex = -1;
		
		try
		{
			//Save
			var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
			var GeometryList;
			var GeometryStore;
			var GeometryIndex;
			var Name;
			var Width;
			var Height;
			var Left;
			var Top;
			
			
			GeometryStore = '';
			GeometryList = document.getElementById("customgeometry.options.GeometryList");
			
			for (GeometryIndex=0; GeometryIndex<GeometryList.getRowCount(); GeometryIndex++)
			{
				if (GeometryStore != '')
					GeometryStore += '~';
				
				OneRow = GeometryList.getItemAtIndex(GeometryIndex);
				
				Name = OneRow.childNodes[0].getAttribute('label');
				Height = OneRow.childNodes[1].getAttribute('label');
				Width = OneRow.childNodes[2].getAttribute('label');
				Left = OneRow.childNodes[3].getAttribute('label');
				Top = OneRow.childNodes[4].getAttribute('label');
				
				GeometryStore += Name + '^';
				GeometryStore += Height + '^';
				GeometryStore += Width + '^';
				GeometryStore += Left + '^';
				GeometryStore += Top;
			}
			
			if(GeometryStore == '')
				GeometryStore = "Default^1192^1170^728^0";
			
			oPrefs.setCharPref("customgeometry.options.list", GeometryStore);
		} catch(err) { alert(err); }
		
		return(true);
	},


	AddRow: function()
	{
		var Fail = 0;
		var GeometryList = document.getElementById("customgeometry.options.GeometryList");
		var Name = document.getElementById("customgeometry.options.name").value;
		var Width = document.getElementById("customgeometry.options.width").value;
		var Height = document.getElementById("customgeometry.options.height").value;
		var Left = document.getElementById("customgeometry.options.left").value;
		var Top = document.getElementById("customgeometry.options.top").value;
		var OneRow;
		var OneCell;
		
		
		CustomGeometrySetup.SelectedIndex = -1;
		
		if (Name == '')
			Fail = 1;
		
		if (Width == '')
			Fail = 1;
		
		if (Height == '')
			Fail = 1;
		
		if (Left == '')
			Fail = 1;
		
		if (Top == '')
			Fail = 1;
		
		if (Fail)
		{
			alert('Please check your chosen geometry.  Something is blank.');
		}
		else
		{
			OneRow = document.createElement("listitem");
			
			OneCell = document.createElement("listcell");
			OneCell.setAttribute("label", Name);
			OneRow.appendChild(OneCell);
			
			OneCell = document.createElement("listcell");
			OneCell.setAttribute("label", Width);
			OneRow.appendChild(OneCell);
			
			OneCell = document.createElement("listcell");
			OneCell.setAttribute("label", Height);
			OneRow.appendChild(OneCell);
			
			OneCell = document.createElement("listcell");
			OneCell.setAttribute("label", Left);
			OneRow.appendChild(OneCell);
			
			OneCell = document.createElement("listcell");
			OneCell.setAttribute("label", Top);
			OneRow.appendChild(OneCell);
			
			GeometryList.appendChild(OneRow)
		}
	},


	DeleteRow: function()
	{
		var GeometryList = document.getElementById("customgeometry.options.GeometryList");
		var SelectedCount = GeometryList.selectedCount;
		var OneRow;
		
		
		CustomGeometrySetup.SelectedIndex = -1;
		
		while (SelectedCount--)
		{
			OneRow = GeometryList.selectedItems[0];
			GeometryList.removeItemAt(GeometryList.getIndexOfItem(OneRow));
		}
	},


	UpdateRow: function()
	{
		var GeometryList = document.getElementById("customgeometry.options.GeometryList");
		var OldRow;
		var OneRow;
		var OneCell;
		var Name = document.getElementById("customgeometry.options.name").value;
		var Width = document.getElementById("customgeometry.options.width").value;
		var Height = document.getElementById("customgeometry.options.height").value;
		var Left = document.getElementById("customgeometry.options.left").value;
		var Top = document.getElementById("customgeometry.options.top").value;
		var Fail = 0;
		
		
		if (CustomGeometrySetup.SelectedIndex >= 0)
		{
			OldRow = GeometryList.childNodes[CustomGeometrySetup.SelectedIndex];
			
			if (Name == '')
				Fail = 1;
			
			if (Width == '')
				Fail = 1;
			
			if (Height == '')
				Fail = 1;
			
			if (Left == '')
				Fail = 1;
			
			if (Top == '')
				Fail = 1;
			
			if (Fail)
			{
				alert('Please check your chosen geometry.  Something is blank.');
			}
			else
			{
				OneRow = document.createElement("listitem");
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Name);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Width);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Height);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Left);
				OneRow.appendChild(OneCell);
				
				OneCell = document.createElement("listcell");
				OneCell.setAttribute("label", Top);
				OneRow.appendChild(OneCell);
				
				GeometryList.insertBefore(OneRow, OldRow);
				GeometryList.removeItemAt(GeometryList.getIndexOfItem(OldRow));
			}
		}
	},


	ClickRow: function()
	{
		var GeometryList = document.getElementById("customgeometry.options.GeometryList");
		var OneRow;
		var Name;
		var Width;
		var Height;
		var Left;
		var Top;
		
		if (GeometryList.selectedCount)
		{
			OneRow = GeometryList.selectedItems[0];
			SelectedIndex = GeometryList.getIndexOfItem(OneRow);		
			
			Name = OneRow.childNodes[0].getAttribute('label');
			Width = OneRow.childNodes[1].getAttribute('label');
			Height = OneRow.childNodes[2].getAttribute('label');
			Left = OneRow.childNodes[3].getAttribute('label');
			Top = OneRow.childNodes[4].getAttribute('label');
			
			document.getElementById("customgeometry.options.name").value = Name;
			document.getElementById("customgeometry.options.width").value = Width;
			document.getElementById("customgeometry.options.height").value = Height;
			document.getElementById("customgeometry.options.left").value = Left;
			document.getElementById("customgeometry.options.top").value = Top;
		}
	}
}
